
#################################################
#
# model configuration: init.conf only
#
# This is the most outer domain of Kobe Product Run
#
#################################################

&PARAM_IO
 IO_LOG_BASENAME = "init_LOG",
/

&PARAM_TIME
 TIME_STARTDATE = 2010, 5, 1, 0, 0, 0,
 TIME_STARTMS   = 0.D0,
/

&PARAM_STATISTICS
 STATISTICS_checktotal     = .true.,
 STATISTICS_use_globalcomm = .true.,
/

&PARAM_RESTART
 RESTART_OUTPUT         = .true.,
 RESTART_OUT_BASENAME   = "init",
/

&PARAM_TOPO
 TOPO_IN_BASENAME = "topo",
/

&PARAM_LANDUSE
 LANDUSE_IN_BASENAME  = "landuse",
/

&PARAM_LAND_PROPERTY
 LAND_PROPERTY_IN_FILENAME = "param.bucket.conf",
/

&PARAM_MKINIT
 MKINIT_initname = "REAL",
/

&PARAM_MKINIT_REAL_ATMOS
 BASENAME_BOUNDARY   = "boundary",
 FILETYPE_ORG        = "GrADS",
 NUMBER_OF_FILES     = 12,
 NUMBER_OF_TSTEPS    = 1,
 BOUNDARY_UPDATE_DT  = 21600.D0,
 PARENT_MP_TYPE       = 3,
 USE_FILE_DENSITY     = .false.,
/
&PARAM_MKINIT_REAL_LAND
 USE_FILE_LANDWATER   = .true.,
 INTRP_LAND_SFC_TEMP = 'mask',
 INTRP_LAND_TEMP     = 'fill',
 INTRP_LAND_WATER    = 'fill',
/
&PARAM_MKINIT_REAL_OCEAN
 INTRP_OCEAN_SFC_TEMP = 'mask',
 INTRP_OCEAN_TEMP     = 'mask',
/

&PARAM_MKINIT_REAL_GRADS
 grads_boundary_namelist = "namelist.grads_boundary.FNL",
/

&PARAM_NEST
 NEST_INTERP_LEVEL   = 4,
/


#################################################
#
# model configuration: process
#
#################################################

&PARAM_PRC
 PRC_NUM_X      = 4,
 PRC_NUM_Y      = 4,
 PRC_PERIODIC_X = .false.,
 PRC_PERIODIC_Y = .false.,
/

#################################################
#
# model configuration: region
#
#################################################

&PARAM_INDEX
 KMAX = 35,
 IMAX = 40,
 JMAX = 40,
/

&PARAM_LAND_INDEX
 LKMAX = 5,
/

&PARAM_URBAN_INDEX
 UKMAX = 5,
/

&PARAM_LAND_GRID
 LDZ = 0.05D0, 0.15D0, 0.30D0, 0.50D0, 1.00D0,
/

&PARAM_URBAN_GRID
 UDZ = 0.01D0, 0.01D0, 0.03D0, 0.05D0, 0.10D0,
/

&PARAM_GRID
 DX = 7500.D0,
 DY = 7500.D0,
 FZ(:) =    161.6830D0,   335.9580D0,   523.8060D0,   726.2850D0,   944.5340D0,
           1179.7810D0,  1433.3490D0,  1706.6670D0,  2001.2720D0,  2318.8220D0,
           2661.1040D0,  3030.0450D0,  3427.7200D0,  3856.3680D0,  4318.4000D0,
           4816.4180D0,  5353.2230D0,  5931.8370D0,  6555.5160D0,  7227.7690D0,
           7952.3800D0,  8733.4280D0,  9575.3060D0, 10482.7500D0, 11460.8800D0,
          12515.1800D0, 13651.6000D0, 14876.5200D0, 16196.8500D0, 17620.0100D0,
          19154.0100D0, 20807.4900D0, 22589.7400D0, 24510.8100D0, 26581.5000D0,
 BUFFER_DZ = 5000.D0,
 BUFFER_DX = 150000.0D0,
 BUFFER_DY = 150000.0D0,
/

&PARAM_MAPPROJ
 MPRJ_basepoint_lon = 135.220404D0,
 MPRJ_basepoint_lat = 34.653396D0,
 MPRJ_type          = 'LC',
 MPRJ_LC_lat1       =  30.00D0,
 MPRJ_LC_lat2       =  40.00D0,
/

#################################################
#
# model configuration: administrator
#
#################################################

&PARAM_CONST
 CONST_THERMODYN_TYPE = "SIMPLE",
/

&PARAM_TRACER
 TRACER_TYPE = "TOMITA08",
/

&PARAM_ATMOS
 ATMOS_DYN_TYPE    = "HEVI",
 ATMOS_PHY_MP_TYPE = "TOMITA08",
 ATMOS_PHY_RD_TYPE = "MSTRNX",
 ATMOS_PHY_SF_TYPE = "COUPLE",
 ATMOS_PHY_TB_TYPE = "MYNN",
/

&PARAM_OCEAN
 OCEAN_TYPE = "CONST",
/

&PARAM_LAND
 LAND_TYPE = "SLAB",
/

&PARAM_URBAN
 URBAN_TYPE = "SLC",
/
